#include <stdio.h>
#include <stdarg.h>

int
scanf (const char *fmt, ...)
{
	va_list args;
	int n;

	va_start (args, fmt);
	n = _doscan (stdin, fmt, args);
	va_end (args);
	return n;
}

int
fscanf (FILE *iop, const char *fmt, ...)
{
	va_list args;
	int n;

	va_start (args, fmt);
	n = _doscan(iop, fmt, args);
	va_end (args);
	return n;
}

int
sscanf (const char *str, const char *fmt, ...)
{
	FILE _strbuf;
	va_list args;
	int n;

	_strbuf.flags = __SRD|__SWR;
	_strbuf.buf = (void*) str;
	_strbuf.len = 0;
	while (*str++)
		_strbuf.len ++;
	_strbuf.size = _strbuf.len;
	_strbuf.len = 0;
	va_start (args, fmt);
	n = _doscan(&_strbuf, fmt, args);
	va_end (args);
	return n;
}
