#include <stdio.h>
#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_sys.h>
#include <p32mx/p32mx_uart.h>
#include <p32mx/p32mx_port.h>
#include <p32mx/console.h>

#define UART_CH	0
static inline void serial_setbrg(const long baud) {
	U_BRG(UART_CH)  =  (clkc_get_pbclk()/16/baud - 1 ) & 0xffff;
}

// Olimex PIC32-PINGUINO-MX220 
//    LED1 (Green) D13 = RB15 Active H (1: Light on)
//    LED2 (Red  ) D9  = RA10 Active H (1: Light on)
//    BUT          D8  = RB7  Active L (0 : Pressed)

uint8_t heap_area[256] HEAP_SECTION;

#if 0
void 
__attribute__((section(".gen_handler0")))
never_return()
{
	uint32_t c0_cause;
	int i,x;
	for (i=0;;i++) {
		__delay_loop_1(2000000);
		c0_cause = read_c0_cause();
		x = (c0_cause >> 2) & 0x1f;
		if (x < 5) {
			regx_inv(LAT, 1, 10); // red
			regx_clr(LAT, 0, 15); // green
		}
		else {
			regx_clr(LAT, 1, 10); // red
			regx_inv(LAT, 0, 15); // green
		}
	}
}
#endif

int main() {
	int i;
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_set(LAT , 1, 15);
	regx_clr(LAT , 0, 10);

	for (i=0;i<5;i++) {
		__delay_loop_1(10000000);
		regx_inv(LAT, 0, 10);
	}
	serial_init(0);
	jzcon_setup();
	for (i=0;i<5;i++) {
		__delay_loop_1(10000000);
		regx_inv(LAT, 1, 15);
	}
	serial_setbrg(50);
	RPB15R = PPS1_OUT_U1TX;; // assign PB15
	printf("hello world\n");
        regx_clr(LAT , 1, 15);
        RPB15R = PPS1_OUT_NONE;; // assign PB15
	for (i=0;i<4;i++) {
		__delay_loop_1(10000000);
		regx_inv(LAT, 1, 15);
	}
	for (;;) {
	}
}
