#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_port.h>
#include <p32mx/interrupt.h>
#include <p32mx/timer.h>

// Olimex PIC32-PINGUINO-MX220 
//    LED1 (Green) D13 = RB15 Active H (1: Light on)
//    LED2 (Red  ) D9  = RA10 Active H (1: Light on)
//    BUT          D8  = RB7  Active L (0 : Pressed)

#if 1
void __intent();
void 
__attribute__((section(".gen_handler0")))
never_return()
{
	uint32_t c0_cause;
	int i,x;
	for (i=0;;i++) {
		__delay_loop_1(1000000);
		c0_cause = read_c0_cause();
		x = (c0_cause >> 2) & 0x1f;
		if (x < 5)
			LAT_INV(0)  = 1 << 10; // red
		c0_cause = read_c0_epc();
		//if ((uint32_t)ostimer_entry >= c0_cause) // lighted
		//if ((uint32_t)intent >= c0_cause) // lighted
		if (0x9d004400 >= c0_cause) // lighted
		//if ((uint32_t)__intent >= c0_cause) // not lighted
			LAT_INV(1)  = 1 << 15; // green
	}
}
#endif

void timer_entry()
{
	regx_inv(LAT , 0, 10);
}

int main() {
	int i;
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_clr(LAT , 1, 15);
	regx_clr(LAT , 0, 10);
	interrupt_enable();
	timer_callback = timer_entry;
	//timer_start(100);
	//__timer_start(3, 50000);  // 40M / 8 / 50000 = 100
	__timer_start(7, 50000);  // 40M / 256 / 50000 = 100/32 (Hz)
	regx_set(LAT , 1, 15);
	for (;;) {
	    for (i=0;i<20;i++) {
		delay_us(500000); // 0.5 sec 
		regx_inv(LAT , 1, 15);
	    }
	    IEC_SET(0) = 0xffffffff;
	    IFS_CLR(0) = 0xffffffff;
	    //__sei();
	    timer_stop();
	    __timer_start(7, 50000);
	}
}
