#ifndef _JZ_OSTIMER_H_
#define _JZ_OSTIMER_H_

#include <stdint.h>

#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define ostimer32		_2xx_ostimer32
  #define ostimer64		_2xx_ostimer64
  #define ostimer_clk		_2xx_ostimer_clk
  #define ostimer_start		_2xx_ostimer_start
  #define __ostimer_start	___2xx_ostimer_start
  #define ostimer_stop		_2xx_ostimer_stop
#elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define ostimer32		_4xx_ostimer32
  #define ostimer64		_4xx_ostimer64
  #define ostimer_clk		_4xx_ostimer_clk
  #define ostimer_start		_4xx_ostimer_start
  #define __ostimer_start	___4xx_ostimer_start
  #define ostimer_stop		_4xx_ostimer_stop
#endif

extern uint32_t ostimer32();
extern uint64_t ostimer64();
extern int ostimer_clk();
extern void __ostimer_start(uint32_t prescale);
extern void ostimer_start(int is_fast); /* 1: 1/1 , 0: 1/64 */
extern void ostimer_stop();

#endif /* _JZ_OSTIMER_H_ */
