#ifndef _JZ_P32MX_NVM_H_
#define _JZ_P32MX_NVM_H_
#include <stdint.h>


#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _nvm_base_addr        (_sfrs_base_addr_0 + 0xF400)
#else
  #define _nvm_base_addr	((const void *)0xBF80F400)
#endif

  #define _NVM_ADDR	(_nvm_base_addr)

  #define NVMCON           (*(volatile uint16_t *)(_NVM_ADDR + 0x00))
  #define NVMCON_CLR       (*(volatile uint16_t *)(_NVM_ADDR + 0x04))
  #define NVMCON_SET       (*(volatile uint16_t *)(_NVM_ADDR + 0x08))
  #define NVMCON_INV       (*(volatile uint16_t *)(_NVM_ADDR + 0x0C))

  #define NVMKEY           (*(volatile uint32_t *)(_NVM_ADDR + 0x10))
  #define NVMADDR          (*(volatile uint32_t *)(_NVM_ADDR + 0x20))
  #define NVMADDR_CLR      (*(volatile uint32_t *)(_NVM_ADDR + 0x24))
  #define NVMADDR_SET      (*(volatile uint32_t *)(_NVM_ADDR + 0x28))
  #define NVMADDR_INV      (*(volatile uint32_t *)(_NVM_ADDR + 0x2C))
  #define NVMDATA          (*(volatile uint32_t *)(_NVM_ADDR + 0x30))
  #define NVMSRCADDR       (*(volatile uint32_t *)(_NVM_ADDR + 0x40))

    #define NVMCON_NVMOP                   0x00
    #define NVMCON_LVDSTAT                 0x0B
    #define NVMCON_LVDERR                  0x0C
    #define NVMCON_WRERR                   0x0D
    #define NVMCON_WREN                    0x0E
    #define NVMCON_WR                      0x0F

//    #define NVMCON_PROGOP                  0x00

  #define NVM_OP_FLASH_ERASE	0x4005
  #define NVM_OP_PAGE_ERASE	0x4004
  #define NVM_OP_PROGRAM_WORD	0x4001
  #define NVM_OP_PROGRAM_ROW	0x4003
  #define NVM_OP_PROGRAM_NOP	0x4000

  #define NVMKEY_VAL1	0xAA996655
  #define NVMKEY_VAL2	0x556699AA

/* erase 4KB (page = 4KB) */
extern void __nvm_page_erase(uint32_t paddr); 

/* program 32bit = 4B */
extern void __nvm_program_word(uint32_t paddr, uint32_t data); 

/* program 32bit x 128 = 512B (src : ram addr) */
extern void __nvm_program_row128(uint32_t paddr, void *src); 

#endif /* _JZ_P32MX_NVM_H_ */
